'*****************************************************************************
' Pelles C compatible (SAPI 5.x) Text-To_Speech sample
'                           (c) by Kevin Diggins 2005
' Revised by Robert Wishlaw June 20 2014
'*****************************************************************************

GUI "TeenyTalker",0, ICON, 600

$HEADER
/* SpVoice Class */
//DEFINE_GUID(CLSID_SpVoice,0x96749377,0x3391,0x11D2,0x9E,0xE3,0x00,0xC0,0x4F,0x79,0x73,0x96);
const GUID CLSID_SpVoice = {0x96749377,0x3391,0x11D2,0x9E,0xE3,0x00,0xC0,0x4F,0x79,0x73,0x96};
/* ISpVoice Interface */
//DEFINE_GUID(IID_ISpVoice,0x6C44DF74,0x72B9,0x4992,0xA1,0xEC,0xEF,0x99,0x6E,0x04,0x22,0xD4);
const GUID IID_ISpVoice = {0x6C44DF74,0x72B9,0x4992,0xA1,0xEC,0xEF,0x99,0x6E,0x04,0x22,0xD4};
$HEADER

DIM str1$

SUB FORMLOAD
  Initialize ()

  Form1   = BCX_FORM (FrmCaption$,0,0,323,270,Style,WS_EX_STATICEDGE)
  SendMessage (Form1, WM_SETICON, TRUE, LoadIcon(GetModuleHandle(0),(LPSTR)600))
  MODSTYLE (Form1, 0, WS_MAXIMIZEBOX)

  Button1 = BCX_BUTTON     ("Load"  , Form1, 102,   5, 3, 36, 15, 0, -1)
  Button2 = BCX_BUTTON     ("Play"  , Form1, 103,  40, 3, 36, 15, 0, -1)
  Button3 = BCX_BUTTON     ("Pause" , Form1, 104,  75, 3, 36, 15, 0, -1)
  Button4 = BCX_BUTTON     ("Stop"  , Form1, 105, 110, 3, 36, 15, 0, -1)
  Button5 = BCX_BUTTON     ("Paste" , Form1, 106, 180, 3, 36, 15, 0, -1)
  Button6 = BCX_BUTTON     ("Clear" , Form1, 107, 215, 3, 36, 15, 0, -1)
  Button7 = BCX_BUTTON     ("About" , Form1, 108, 250, 3, 36, 15, 0, -1)
  Button8 = BCX_BUTTON     ("Quit"  , Form1, 109, 285, 3, 36, 15, 0, -1)
  Icon1   = BCX_OLEPICTURE (  ""    , Form1, 500, 147, 2,  0,  0, 500)
  Text1   = BCX_LABEL      ("Volume", Form1,   0, 134, 47)
  Text2   = BCX_LABEL      ("Pitch" , Form1,   0, 206, 47)
  Text3   = BCX_LABEL      ("Speed" , Form1,   0, 272, 47)
  Combo1  = BCX_COMBOBOX   (  ""    , Form1, 110,   7, 27, 100, 75)
  RichEd1 = BCX_RICHEDIT   (Sample$ , Form1 ,101,   7, 61, 310, 200)

  CALL LoadVoices
'   SendMessage (Combo1, CB_ADDSTRING, 0, "Microsoft Anna")
' **************************************************************************
  TrkBar1 = BCX_CONTROL("msctls_trackbar32", Form1, "", _
  111, 108,   22, 70, 24, TBS_BOTH  or WS_VISIBLE or WS_CHILD)
  SendMessage(TrkBar1, TBM_SETRANGE,TRUE,MAKELONG(0,100))        'Set Volume
  SendMessage(TrkBar1, TBM_SETPOS,TRUE,50)                       'Half Way
' **************************************************************************
  TrkBar2 = BCX_CONTROL("msctls_trackbar32", Form1, "", _
  112, 180, 22, 70, 24, TBS_BOTH  or WS_VISIBLE or WS_CHILD)
  SendMessage(TrkBar2, TBM_SETRANGE,TRUE,MAKELONG(0,20))         'Set Pitch
  SendMessage(TrkBar2, TBM_SETPOS,TRUE,10)                        'Half Way
' **************************************************************************
  TrkBar3 = BCX_CONTROL("msctls_trackbar32", Form1, "", _
  113, 250, 22, 70, 24, TBS_BOTH  or WS_VISIBLE or WS_CHILD)
  SendMessage(TrkBar3, TBM_SETRANGE,TRUE,MAKELONG(0,20))         'Set Speed
  SendMessage(TrkBar3, TBM_SETPOS,TRUE,10)                        'Half Way
' **************************************************************************
  CENTER (Form1)
  SHOW   (Form1)
  CoInitialize(NULL)
END SUB


BEGIN EVENTS
SELECT CASE CBMSG
  CASE WM_COMMAND
  SELECT CASE CBCTL
'***********************************************************************
    CASE 102                                               ' Load A File
'***********************************************************************
    DIM RAW File$
    DIM RAW Mask$
    Mask$ = "Txt Files(*.txt)|*.Txt|Rtf Files(*.rtf)|*.Rtf|All Files(*.*)|*.*"
    File$ = GETFILENAME$ ("OPEN",Mask$)
    IF LOF(File$) > 1048576 THEN
      MSGBOX "File must be less than 1,048,576 bytes"
      EXIT FUNCTION
    END IF
    IF File$ > "" THEN EDITLOADFILE(RichEd1, File$)
'***********************************************************************
    CASE 103                                                      ' Play
'***********************************************************************
    SetWindowText(Button3,"Pause")
    PauseFlag = FALSE
    Speak (BCX_GET_TEXT$(RichEd1))
'***********************************************************************
    CASE 104                                               'Pause/Resume
'***********************************************************************
    PauseFlag = NOT PauseFlag
    IF PauseFlag THEN
      SetWindowText(Button3,"Resume")
      IF pVoice THEN
        pVoice->lpVtbl->Pause(pVoice)
      END IF
    ELSE
      SetWindowText(Button3,"Pause")
      PauseFlag = FALSE
      IF pVoice THEN
        pVoice->lpVtbl->Resume(pVoice)
      END IF
    END IF
'**********************************************************************
    CASE 105                                                      'Stop
'**********************************************************************
    SetWindowText(Button3,"Pause")
    PauseFlag = FALSE
    IF pVoice THEN
      pVoice->lpVtbl->Release(pVoice)
      pVoice = NULL
    END IF
'*********************************************************************
    CASE 106                                          'Paste Clipboard
'*********************************************************************
    PasteClipBoard()
'*********************************************************************
    CASE 107
'*********************************************************************
    BCX_SET_TEXT(RichEd1,"")                               'Erase Window
'*********************************************************************
    CASE 108                                                    'About
'*********************************************************************
    Dim RAW MyMsg$
    MyMsg$ = "  Teeny Talker" + CRLF$ + "    Version 1.3" + CRLF$ + _
    "(c) Kevin Diggins" + CRLF$ + "  November 2005" + CRLF$ + CRLF$
    MsgBox MyMsg$, "About", MB_OK
    EXIT FUNCTION
'*********************************************************************
    CASE 109                                                     'Quit
'*********************************************************************
    SendMessage(Form1,WM_CLOSE,0,0)
'*********************************************************************
  END SELECT
'*********************************************************************
  CASE WM_CLOSE
'*********************************************************************
  DIM RAW id
  id =  MessageBox (hWnd, "Are you sure?", "Quit Program!", MB_YESNO)
  IF id = IDYES THEN
    CoUninitialize()
    DestroyWindow (hWnd)
  END IF
  EXIT FUNCTION
END SELECT
END EVENTS




SUB Speak(A$)

  #INCLUDE <SAPI.H>
  $LIBRARY <OLE32.LIB>
  $LIBRARY <OLEAUT32.LIB>
'*********************************************************************
  DIM x,y,z,i
  DIM Voice$
  DIM B$ * (LEN(A$)*2)
  DIM RAW Flags = SVSFPurgeBeforeSpeak | SVSFlagsAsync | SVSFIsXML
'*********************************************************************

  IF pVoice THEN                         'If we're talking, be quiet!
    pVoice->lpVtbl->Release(pVoice)
  END IF

  IF SUCCEEDED (CoCreateInstance(&CLSID_SpVoice,NULL, _
  CLSCTX_ALL, &IID_ISpVoice,(void**)&pVoice)) THEN

  x = SendMessage(TrkBar3,TBM_GETPOS,0,0) - 10
  y = SendMessage(TrkBar2,TBM_GETPOS,0,0) - 10
  z = SendMessage(TrkBar1,TBM_GETPOS,0,0)
  i = SendMessage(Combo1,CB_GETCURSEL,0,0)

  SendMessage(Combo1,CB_GETLBTEXT,i,Voice$)

  B$ =      "<rate absspeed=" & DQ$ & TRIM$(STR$(x)) & DQ$ & ">" 'Values for the rate property range from -10 to 10
  B$ = B$ + "<pitch absmiddle=" & DQ$ & TRIM$(STR$(y)) & DQ$ & ">" 'Values for the pitch property range from -10 to +10
  B$ = B$ + "<volume level=" & DQ$ & TRIM$(STR$(z)) & DQ$ & ">" 'Values for the volume property range from 0 to 100
  B$ = B$ + "<voice required='name=" + Voice$ + "'>"

  B$ = B$ + A$
  B$ = B$ + "</voice>"
  B$ = B$ + "</volume>"
  B$ = B$ + "</pitch>"
  B$ = B$ + "</rate>"

' ************************************************
' These are my custom modifications to the lexicon
' ************************************************

  REPLACE " Re:" WITH "regarding" IN B$
  REPLACE " re:" WITH "regarding" IN B$
  REPLACE "*"  WITH ""  IN B$
  REPLACE "_"  WITH ""  IN B$
  REPLACE ":"  WITH ""  IN B$

' ************************************************
  pVoice->lpVtbl->Speak(pVoice,ANSITOWIDE(B$),Flags,0)
END IF
END SUB

SUB PasteClipBoard
  Dim hClip AS LPSTR
  OpenClipboard(NULL)
  hClip = GetClipboardData(CF_TEXT)
  CloseClipboard()
  DIM Tmp$ * LEN(hClip)+1
  Tmp$ = hClip
  SETWINDOWRTFTEXT(RichEd1,Tmp$)
END SUB

SUB Initialize
  CONST FrmCaption$ = "Teeny Talker (c) Kevin Diggins 2005"
  GLOBAL Form1   AS CONTROL
  GLOBAL RichEd1 AS CONTROL
  GLOBAL Button1 AS CONTROL
  GLOBAL Button2 AS CONTROL
  GLOBAL Button3 AS CONTROL
  GLOBAL Button4 AS CONTROL
  GLOBAL Button5 AS CONTROL
  GLOBAL Button6 AS CONTROL
  GLOBAL Button7 AS CONTROL
  GLOBAL Button8 AS CONTROL
  GLOBAL TrkBar1 AS Control
  GLOBAL TrkBar2 AS Control
  GLOBAL TrkBar3 As Control
  GLOBAL Text1   AS CONTROL
  GLOBAL Text2   AS CONTROL
  GLOBAL Text3   AS CONTROL
  GLOBAL Combo1  AS CONTROL
  GLOBAL Icon1   AS CONTROL

  GLOBAL pVoice  AS ISpVoice PTR
  GLOBAL PauseFlag
  GLOBAL Style
  GLOBAL Sample$
  GLOBAL i

  Style = DS_MODALFRAME | WS_MINIMIZEBOX | WS_POPUP | WS_CAPTION | WS_SYSMENU

  WHILE DATA$[i] <> "EOD"
    Sample$ = Sample$ + DATA$[i] + CRLF$
    i++
  WEND
END SUB

DATA "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fmodern\fprq1\"
DATA "fcharset0 Courier New;}{\f1\fnil\fcharset0 Times New Roman;}}"
DATA "{\colortbl ;\red0\green128\blue0;\red0\green128\blue128;}"
DATA "\viewkind4\uc1\pard\qc\f0\fs28 The following is the first line from\par"
DATA "\par"
DATA "\cf1\b\fs40 A Tale of Two Cities\cf0\fs28\par"
DATA "\b0\par"
DATA "\cf2 by Charles Dickens\cf0 .\par"
DATA "\fs24\par"
DATA "It was the best of times, it was the worst of times,\par"
DATA "it was the age of wisdom, it was the age of foolishness,\par"
DATA "it was the epoch of belief, it was the epoch of incredulity,\par"
DATA "it was the season of Light, it was the season of Darkness,\par"
DATA "it was the spring of hope, it was the winter of despair,\par"
DATA "we had everything before us, we had nothing before us, we\par"
DATA "were all going direct to Heaven, we were all going direct\par"
DATA "the other way, in short, the period was so far like the\par"
DATA "present period, that some of its noisiest authorities insisted\par"
DATA "on its being received, for good or for evil, \par"
DATA "in the superlative degree of comparison only.\f1\fs20\par"
DATA "}"
DATA "EOD"

SUB LoadVoices
  DIM tts        AS OBJECT
  DIM VoiceCount AS LONG
  DIM Voice$
  DIM str1$

  SET tts = CreateObject("Sapi.SpVoice")
  VoiceCount = tts.GetVoices.Count
  DECR VoiceCount

  FOR INTEGER i = 0 to VoiceCount
    str1$ = tts.GetVoices().Item(i).GetDescription
    Voice$ = EXTRACT$(str1$, " -")
    SendMessage (Combo1, CB_ADDSTRING, 0, Voice$)
  NEXT

  SendMessage (Combo1, CB_SETCURSEL, 0, 0)
  Set tts = NOTHING
END SUB

